--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...

local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Graphics\\Statusbars\\LightGrey"})
    frame:SetBackdropColor(1,0,0,0.65)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateClassPowerBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(1,.5,.5,1)
	frame:SetBackdropBorderColor(0,0,0,1)
end
--UnitSpecific.arena = UnitSpecific.boss
local UnitSpecific = {
	boss = function(self)
	self:SetSize(135,60)


		self.Portrait:SetPoint('TOPRIGHT', self.Health, 'TOPLEFT', 0,0)
		self.Portrait:SetSize(65, 65)

		self.Health:SetHeight(65-20)
		self.Power:SetHeight(65-45)

		self.Castbar:SetSize(225+65, 25)
		self.Castbar:SetPoint('BOTTOM', self.Power, -32, -27)

	local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0,60)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 60)
			Auras:SetHeight(30)
			Auras:SetHeight(30 + 4)

			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.gap = 5
			Auras.spacing = 4
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 16

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
			---Raid Target
			-- Position and size
    local RaidTargetIndicator = self:CreateTexture(nil, 'OVERLAY')
    RaidTargetIndicator:SetSize(20, 20)
    RaidTargetIndicator:SetPoint('TOPRIGHT', self)

    -- Register it with oUF
    self.RaidTargetIndicator = RaidTargetIndicator

	end, --end boss
	


	
}
	UnitSpecific.arena = UnitSpecific.boss

local Shared = function(self, unit)
	-- Shared layout code.

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\LightGrey")
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')


	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg

	----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\LightGrey")
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-20)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')

	CreatePowerBackdrop(Power)
	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg

	------------------
	--   Portrait --
	------------------



	-- 3D Portrait
	local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")


	

	-- Register it with oUF
	self.Portrait = Portrait


	--------------
	-- Cast Bar --
	--------------

	-- Position and size
	local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Castbar:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\LightGrey")
	
	Castbar:SetStatusBarColor(0.45,0.45,0.45,0.85)


	-- Add a background

	-- Add a spark
	local Spark = Castbar:CreateTexture(nil, "OVERLAY")
	Spark:SetSize(65, 8)
	Spark:SetBlendMode("ADD")

	-- Add a timer
	local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Time:SetFont("Interface\\Addons\\Inked\\Fonts\\Roboto.TTF", 10, "OUTLINE")
	Time:SetTextColor(0.95, 0.95, 0.95)
	Time:SetPoint("RIGHT", Castbar, -3, 1)

	-- Add spell text
	local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Roboto.TTF", 11, "OUTLINE")
	Text:SetTextColor(0.95, 0.95, 0.95)
	Text:SetPoint("LEFT", Castbar, 3, 1)

	-- Add Shield
	local Shield = Castbar:CreateTexture(nil, "OVERLAY")
	Shield:SetSize(25, 15)
	Shield:SetPoint("CENTER", Castbar)

	local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
    Icon:SetSize(26, 26)
    Icon:SetPoint('LEFT', Castbar, 'LEFT',-25,0)
	-- Add safezone
	local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")

	-- Register it with oUF
	self.Castbar = Castbar
	self.Castbar.bg = Background
	self.Castbar.Spark = Spark
	self.Castbar.Time = Time
	self.Castbar.Text = Text
	self.Castbar.SafeZone = SafeZone
	self.Castbar.Icon = Icon

	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedBoss", Shared)
oUF:Factory(function(self)

	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("InkedBoss")
    
	--  self:Spawn("boss"):SetPoint("CENTER",UIParent,"CENTER",200,150)
	  
	  for index = 1, 5 do
		local boss = self:Spawn('boss' .. index)

		if(index == 1) then
			boss:SetPoint("CENTER",UIParent,"CENTER",200,150)
		else
			boss:SetPoint('TOP', _G['oUF_InkedBoss' .. index - 1], 'BOTTOM', 0, -20)
		end
	end

end)
